var currentURLIndex;
var currentID;
var imageURL = '/latest.gif';   

var URLs = new Array("N0R",
                     "NCR",
                     "N0V",
                     "N0S",
                     "N1P",
                     "NTP");

function show ()
{
    var now = new Date();

    document.getElementById('cities').src = "http://radar.weather.gov/ridge/Overlays/Cities/Short/" + currentID.toUpperCase() + "_City_Short.gif?" + now.getTime();
    document.getElementById('county').src = "http://radar.weather.gov/ridge/Overlays/County/Short/" + currentID.toUpperCase() + "_County_Short.gif?" + now.getTime();
    document.getElementById('radar').src = "http://radar.weather.gov/ridge/RadarImg/" + URLs[currentURLIndex] + "/" + currentID.toUpperCase() + "_" + URLs[currentURLIndex] + "_0.gif?" + now.getTime();
    document.getElementById('warnings').src = "http://radar.weather.gov/ridge/Warnings/Short/" + currentID.toUpperCase() + "_Warnings_0.gif?" + now.getTime();
    document.getElementById('legend').src = "http://radar.weather.gov/ridge/Legend/" + URLs[currentURLIndex] + "/" + currentID.toUpperCase() + "_" + URLs[currentURLIndex] + "_Legend_0.gif?" + now.getTime();
}

function loaded ()
{
    currentURLIndex = 0;
    currentID = 'ATX';
    
    if (window.widget)
    {
        widget.onshow = onshow;
    }
    
    if(window.widget)
    {
        var location = widget.preferenceForKey("location");
        
        if (location && location.length > 0)
        {
            
            if (location.length == 4)
            {
                location = location.substring(1);
                widget.setPreferenceForKey(location, "location");
            }
            alert("setting");
            currentID = location;
        }
    }

    show();
    
    if (window.widget)
    {
        var width = widget.preferenceForKey("width");
        var height = widget.preferenceForKey("height");
        
        if (width && height)
        {
            if (width == height)
            {
                height = Math.floor(width / 1.090909090909);
                widget.setPreferenceForKey(height, "height");
            }
            
            if ((width > 600) || (height > 550))
            {
                width = 600;
                height = 550;
                widget.setPreferenceForKey(height, "height");
                widget.setPreferenceForKey(width, "width");
            }
            
            if ((width < 351) || (height < 301))
            {
                width = 351;
                height = 301;
                widget.setPreferenceForKey(height, "height");
                widget.setPreferenceForKey(width, "width");
            }

            window.resizeTo(width, height);
            document.getElementById('black').height = height;
            document.getElementById('black').width = width;
            document.getElementById('cities').height = height;
            document.getElementById('cities').width = width;
            document.getElementById('county').height = height;
            document.getElementById('county').width = width;
            document.getElementById('radar').height = height;
            document.getElementById('radar').width = width;
            document.getElementById('warnings').height = height;
            document.getElementById('warnings').width = width;
            document.getElementById('legend').height = height;
            document.getElementById('legend').width = width;
        }
    }
    
    var doneButton = document.getElementById('done');
    createGenericButton(doneButton, 'Done', showFront);
    
    var infoButton = document.getElementById('info');
    createGenericButton(infoButton, 'More Info', goInfo);
}

function goInfo()
{
    widget.openURL('http://www.srh.noaa.gov/jetstream/doppler/radarfaq.htm#diff');
}

function onshow ()
{
    show();
}


function cycle()
{
    var back = document.getElementById("back");

    if (back.style.display != "block")
    {
        currentURLIndex = currentURLIndex + 1;
    
        if (currentURLIndex == URLs.length)
        {
            currentURLIndex = 0;
        }
        
        show();
    }
}

function locationchanged(elem)
{	
    var selection = elem.options[elem.selectedIndex].value;
    
    if (selection.length > 0)
    {
	   currentID = selection;
	}
	
	currentURLIndex = 0;
	
	show();
	
	if (window.widget)
	{
		widget.setPreferenceForKey(currentID, "location");
	}
}


var lastPos;

function mouseResizeDown(event)
{
    var x = event.x + window.screenX;
    var y = event.y + window.screenY;
        
    document.addEventListener("mousemove", mouseResizeMove, true);
    document.addEventListener("mouseup", mouseResizeUp, true);
    lastPos = {x:x, y:y};
    event.stopPropagation();
    event.preventDefault();
}

function mouseResizeMove(event)
{
    var screenX = event.x + window.screenX;
    var screenY = event.y + window.screenY;
    var amt = screenX - lastPos.x;
                        
    if ((amt + document.getElementById('cities').height > 300) && (amt + document.getElementById('cities').height < 551))
    {
        window.resizeBy(amt, amt);
        lastPos = {x:screenX, y:screenY};
        document.getElementById('black').height = window.innerHeight;
        document.getElementById('black').width = window.innerWidth;
        document.getElementById('cities').height = window.innerHeight;
        document.getElementById('cities').width = window.innerWidth;
        document.getElementById('county').height = window.innerHeight;
        document.getElementById('county').width = window.innerWidth;
        document.getElementById('radar').height = window.innerHeight;
        document.getElementById('radar').width = window.innerWidth;
        document.getElementById('warnings').height = window.innerHeight;
        document.getElementById('warnings').width = window.innerWidth;
        document.getElementById('legend').height = window.innerHeight;
        document.getElementById('legend').width = window.innerWidth;
    }
    event.stopPropagation();
    event.preventDefault();
}

function mouseResizeUp(event)
{
    document.removeEventListener("mousemove", mouseResizeMove, true);
    document.removeEventListener("mouseup", mouseResizeUp, true); 
    event.stopPropagation();
    event.preventDefault();
    
    if (window.widget)
	{
	   widget.setPreferenceForKey(document.getElementById('black').width, "width");
	   widget.setPreferenceForKey(document.getElementById('black').height, "height");
	}
}




function showBack()
{
    var front = document.getElementById("front");
    var back = document.getElementById("back");
        
    if (window.widget)
        widget.prepareForTransition("ToBack");
                
    front.style.display="none";
    back.style.display="block";
        
    if (window.widget)
        setTimeout ('widget.performTransition();', 0); 
}

function showFront()
{
    var front = document.getElementById("front");
    var back = document.getElementById("back");
        
    if (window.widget)
        widget.prepareForTransition("ToFront");
                
    back.style.display="none";
    front.style.display="block";
        
    if (window.widget)
        setTimeout ('widget.performTransition();', 0);
    
    exitflip(null);
}




function enterflip(event)
{
	document.getElementById('fliprollie').style.display = 'block';
}

function exitflip(event)
{
	document.getElementById('fliprollie').style.display = 'none';
}

var flipShown = false;

var animation = {duration:0, starttime:0, to:1.0, now:0.0, from:0.0, timer:null};

function mousemove (event)
{

    if (!flipShown)
    {
        if (animation.timer != null)
        {
            clearInterval (animation.timer);
            animation.timer  = null;
        }
                
        var starttime = (new Date).getTime() - 13;
                
        animation.duration = 500;
        animation.starttime = starttime;
        animation.timer = setInterval ("animate();", 13);
        animation.from = animation.now;
        animation.to = 1.0;
        animate();
        flipShown = true;
    }
}

function mouseexit (event)
{

    if (flipShown)
    {
        // fade in the info button
        if (animation.timer != null)
        {
            clearInterval (animation.timer);
            animation.timer  = null;
        }
                
        var starttime = (new Date).getTime() - 13;
                
        animation.duration = 500;
        animation.starttime = starttime;
        animation.timer = setInterval ("animate();", 13);
        animation.from = animation.now;
        animation.to = 0.0;
        animate();
        flipShown = false;
    }
}

function animate()
{
    var T;
    var ease;
    var time = (new Date).getTime();
                
        
    T = limit_3(time-animation.starttime, 0, animation.duration);
        
    if (T >= animation.duration)
    {
        clearInterval (animation.timer);
        animation.timer = null;
        animation.now = animation.to;
    }
    else
    {
        ease = 0.5 - (0.5 * Math.cos(Math.PI * T / animation.duration));
        animation.now = computeNextFloat (animation.from, animation.to, ease);
    }
        
    document.getElementById('flip').style.opacity = animation.now;
    document.getElementById('legend').style.opacity = animation.now;
}

function limit_3 (a, b, c)
{
    return a < b ? b : (a > c ? c : a);
}

function computeNextFloat (from, to, ease)
{
    return from + (to - from) * ease;
}